
/*
 * Primeiro exerccio do Tutorial de J2ME
 *
 * @author Tarcisio Camara
 */


import java.io.IOException;

import java.util.Vector;
import java.util.Random;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Graphics;


/**
 * Possui as constantes compartilhadas por toda a aplicao
 */
public class Constants {

    /**
     * Constructor
     */
    private Constants() {}

    /** EXIT soft key */
    public static final Command exitCommand =
        new Command("EXIT", Command.EXIT, 2);

    /** PAUSE soft key */
    public static final Command pauseCommand =
        new Command("PAUSE", Command.OK, 1);

    /** RESUME soft key */
    public static final Command resumeCommand =
        new Command("RESUME", Command.OK, 1);

    /** Velocidade vertical da nave */
    public static final short MY_SHIP_VERTICAL_SPEED = 0;

    /** Velocidade horizontal da nave */
    public static final short MY_SHIP_HORIZONTAL_SPEED = 3;

    /** Numero mximo de balas que a nave pode atirar de uma s vez*/
    public static final short NUM_BULLETS = 7;

    /** Imagens da nave */
    public static Image[] shipImage = null;
    public static Image[] blowShipImage = null;
    
    /** Imagens do inimigo*/
    public static Image[] enemyImage = null;
    public static Image[] blowEnemyImage = null;

    /** Imagens da bala */
    public static Image[] bulletImage = null;

    /** Imagem da indicao de vida */
    public static Image lifeImage = null;

    /** Imagem de gameover */
    public static Image gameoverImage = null;

    /** Numero de vidas */
    public static short LIVES = 3;

    /** Fonte usada para escrever na tela */
    public static final Font FONT = Font.getFont(Font.FACE_SYSTEM,
                                        Font.STYLE_PLAIN, Font.SIZE_MEDIUM);

    /** Largura da tela */
    public static int WIDTH;

    /** Altura da tela */
    public static int HEIGHT;
    public static Random random = new Random();

    /**
     * Carrega todas as imagens do jogo
     */
    public static void loadImages() {

        try {
            shipImage      = new Image[]{Image.createImage("/ship1.png"),Image.createImage("/ship2.png")};
            blowShipImage  = new Image[]{Image.createImage("/ship_blow1.png"),Image.createImage("/ship_blow2.png")};
            enemyImage     = new Image[]{Image.createImage("/enemy1.png"),Image.createImage("/enemy2.png")};
            blowEnemyImage = new Image[]{Image.createImage("/enemy_blow1.png"),Image.createImage("/enemy_blow2.png")};
            bulletImage    = new Image[]{Image.createImage(Image.createImage("/bullet.png"))};
            lifeImage      = Image.createImage("/life.png");
        } catch(IOException ioe) {
            System.out.println("ERRO: IOException em loadColorImages()");
            ioe.printStackTrace();
            return;
        }
    }
}
