
/*
 * Primeiro exerccio do Tutorial de J2ME
 *
 * @author Tarcisio Camara
 */

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;


/**
 * Representa a nave do heri
 */
public class Ship extends Sprite{

    /** Indica se est explodindo */
    private boolean isBlown = false;

    /** Array de balas */
    private Fire[] fires;

    /** Contador de balas */
    private short fireCounter;

    /** Nmero de vidas */
    private short life = Constants.LIVES;

    /** Usado para animao */
    private int tick;

    /** Indica se a nave est indo pra esquerda */
    public boolean left;

    /** Indica se a nave est indo pra direita s*/
    public boolean right;

    /**
     * Construtor
     * @param x, Posio x inicial
     * @param y, Posio y inicial
     * @param image Imagens que representam o inimigo
     * @param fires Array com as balas
     */
    public Ship(int x, int y, Image[] image, Fire[] fires) {
        super(x, y, image);
        this.setXspeed(Constants.MY_SHIP_HORIZONTAL_SPEED);
        this.setYspeed(Constants.MY_SHIP_VERTICAL_SPEED);
        this.setVisible(true);
        this.fires = fires;
    }

    /**
     * Renderiza a nave na tela
     */
    public void draw(Graphics g) {
        // Se est explodindo seta a imagem da exploso
        if(isBlown) {
            this.setImage(Constants.blowShipImage);
            if(tick == 9){
               isBlown = false;
               this.setImage(Constants.shipImage);
            }
        }

        //Desenha as imagens de acordo com o tick da animao
        if(tick < 5){
                g.drawImage(this.getImage()[0], this.getX(), this.getY(),
                            g.TOP | g.LEFT);
        }else{
                g.drawImage(this.getImage()[1], this.getX(), this.getY(),
                            g.TOP | g.LEFT);
        }
    }

    /**
     * Atualiza a posio da nave
     */
    public void update() {
        //atualiza o tick
        tick = tick < 10 ? tick + 1 : 0;

        // Deve mover pra esquerda
        if(left){
           ????
        }

        // Deve mover pra direita
        if(right){
           ????
        }
    }

    /**
     * Move a nave pra esquerda
     */
    public void moveLeft(){
        //seta posio X de acordo com velocidade horizontal
        ????
    }

    /**
     * Move a nave pra direita
     */
    public void moveRight(){
        //seta posio X de acordo com velocidade horizontal
        ????
    }

    /**
     * Atira
     */
    public void fire(){
        //seta a posio y da bala
        this.fires [fireCounter].setY(getY() - 3);

        //seta a posio x  da bala no "meio da nave"
        ????

        //faz a bala aparecer usando o metodo de Sprite setVisible
        ????

        //atualiza o contador de balas
        fireCounter++;
        fireCounter %= Constants.NUM_BULLETS;
    }

    /**
     * Atualiza a posio X
     */
    public void setX(int newX) {

        // checa as bordas pra no deixar a nave sair datela
        if(newX + getWidth() > Constants.WIDTH) {
            super.setX(Constants.WIDTH - getWidth()- 1);
        } else if(newX < 0) {
            super.setX(1);
        } else {
            super.setX(newX);
        }
    }

    /* *********************************************/
    /* Mtodos get() e set()
    /* *********************************************/

    public void setLife(short life) {
        this.life = life;
    }

    public short getLife() {
        return this.life;
    }

    public void setBlown(boolean isBlown) {
        this.isBlown = isBlown;
    }

    public boolean isBlown() {
        return isBlown;
    }

}
