
/*
 * Primeiro exerccio do Tutorial de J2ME
 *
 * @author Tarcisio Camara
 */

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;


/**
 * Representa um inimigo
 */
public class Enemy extends Sprite {

    /** Indica se o inimigo est explodindo */
    private boolean isBlown = false;

    /** Indica se o inimigo est morto */
    private boolean dead = false;

    /** Varivel usada para animar as imagens */
    private int tick;

    /** Array usado para sortear a velocidade x do inimigo na sua criao */
    private int[] velX = new int[]{-1,1};

//    /**
//     * Construtor
//     * @param x, Posio x inicial
//     * @param y, Posio y inicial
//     * @param image Imagens que representam o inimigo
//     * @param v, Se o inimigo est visvel ou no
//     */
//    public Enemy(int x, int y, Image[] image, boolean v) {
//        super(x, y, image);
//        int xvel = (Constants.random.nextInt()>>>1) % velX.length;
//        this.setXspeed(velX[xvel]);
//        this.setYspeed(3);
//        this.setVisible(v);
//    }
    /**
     * Construtor
     * @param x, Posio x inicial
     * @param y, Posio y inicial
     * @param initialSequence Sequencia inicial que representam o inimigo
     * @param v, Se o inimigo est visvel ou no
     */
    public Enemy(int x, int y, int[] initialSequence, boolean v) {
    	// Chamar construtor do super, inicializando o frame sequence
    	???
        int xvel = (Constants.random.nextInt()>>>1) % velX.length;
        this.setXspeed(velX[xvel]);
        this.setYspeed(3);
        this.setVisible(v);
    }

    /**
     * Retorna o valor em pontos do inimogo
     */
    public int getScore() {
        return 100;
    }

    /**
     * Indica se o inimigo est explodindo
     */
    public void setBlown(boolean isBlown) {
        this.isBlown = isBlown;
    }

    /**
     * Retorna se o inimigo est explodindo
     */
    public boolean isBlown() {
        return isBlown;
    }
    
    /* ************************************************************/
    /* Comportamento do mtodo draw() foi movido para update().
    /* A definio do frame a ser renderizado passa a fazer parte
    /* da lgica, no mais da pintura.
    /* ************************************************************/

//    /**
//     * Responsvel por renderizar as imagens do inimigo.
//     * Controla os frames da animao
//     */
//    public void draw(Graphics g) {
//        // se est explodindo seta a imagem da exploso
//        if(isBlown) {
//            this.setImage(Constants.blowEnemyImage);
//            //acabou a animao da exploso, o inimigo morreu
//            if(tick == 9){
//               this.dead = true;
//            }
//        }
//
//        // anima as imagens baseado no tick
//        if(tick < 5){
//                g.drawImage(this.getImage()[0], this.getX(), this.getY(),
//                            g.TOP | g.LEFT);
//        }else{
//                g.drawImage(this.getImage()[1], this.getX(), this.getY(),
//                            g.TOP | g.LEFT);
//        }
//
//    }
//
    /**
     * Atualiza a posio sdo inimigo
     */
    public void update() {
        // atualiza o tick
        tick = tick < 10 ? tick + 1 : 0;

        if(this.isVisible()) {
            // atualiza posio horizontal do inimigo
            setX(getX() + getXspeed());

            // atualiza a posio vertical do inimigo
            setY(getY() + getYspeed());

            //caso saiu da tela,  randomizado uma nova posio
            if(this.getY() > Constants.HEIGHT) {
                this.randomize();
            }
        }

        // Controla os frames da animao
        // se est explodindo seta a imagem da exploso
        if(isBlown) {
            this.setFrameSequence(Constants.???);
            //acabou a animao da exploso, o inimigo morreu
            if(tick == 9){
               this.dead = true;
            }
        }

        // anima as imagens baseado no tick
        if(tick < 5){
        	this.setFrame(0);
        }else{
        	this.setFrame(1);
        }
    }

    /**
     * Randomiza a posiao X,Y do inimigo
     */
    public void randomize(){
           this.setX ((Constants.random.nextInt()>>>1)%(Constants.WIDTH - getWidth()));
           this.setY (-getHeight() - ((Constants.random.nextInt()>>>1) % 10));
    }

    /**
     * Retorna o estado do inimigo (morto ou no)
     */
    public boolean isDead(){
      return dead;
    }

}
